



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[LeetCode] 104. Maximum Depth of Binary Tree ☆(二叉树的最大深度)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[LeetCode] 104. Maximum Depth of Binary Tree ☆(二叉树的最大深度)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 13:46:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>描述</h2>
<p>Given a binary tree, find its maximum depth.</p>
<p>The maximum depth is the number of nodes along the longest path from the root node down to the farthest leaf node.</p>
<p>Note:&nbsp;A leaf is a node with no children.</p>
<p>Example:</p>
<p>Given binary tree&nbsp;<code>[3,9,20,null,null,15,7]</code>,</p>
<pre class="prettyprint linenums">    3<br />
   / \<br />
  9  20<br />
    /  \<br />
   15   7</pre>
<p>return its depth = 3.</p>
<h2>解析</h2>
<h3>深度优先搜索DFS</h3>
<p>简单的递归。递归条件是，它的最大深度是它左子树的最大深度和右子树最大深度中较大的那个加1。基础条件是，当遇到空节点时，返回深度为0。该递归的实质是深度优先搜索。</p>
<h3>层序遍历</h3>
<p>一层的节点，依次入队列，依次出队列。</p>
<h2>代码</h2>
<h3>深度优先搜索DFS</h3>
<div>
<pre class="prettyprint linenums">/**<br />
 * Definition for a binary tree node.<br />
 * public class TreeNode {<br />
 *     int val;<br />
 *     TreeNode left;<br />
 *     TreeNode right;<br />
 *     TreeNode(int x) { val = x; }<br />
 * }<br />
 */<br />
class Solution {<br />
    public int maxDepth(TreeNode root) {<br />
        if (null == root) {<br />
            return 0;<br />
        }<br />
        int leftMax = maxDepth(root.left);<br />
        int rightMax = maxDepth(root.right);<br />
        return Math.max(leftMax, rightMax) + 1;<br />
    }<br />
}</pre>
</div>
<h3>层序遍历</h3>
<div>
<pre class="prettyprint linenums">/**<br />
 * Definition for a binary tree node.<br />
 * public class TreeNode {<br />
 *     int val;<br />
 *     TreeNode left;<br />
 *     TreeNode right;<br />
 *     TreeNode(int x) { val = x; }<br />
 * }<br />
 */<br />
class Solution {<br />
    public int maxDepth(TreeNode root) {<br />
        if (null == root) {<br />
            return 0;<br />
        }<br />
        Queue&lt;TreeNode&gt; queue = new LinkedList&lt;&gt;();<br />
        queue.offer(root);<br />
        int nodeSum = 0;<br />
        while (!queue.isEmpty()) {<br />
            nodeSum++;<br />
            int stackSize = queue.size();<br />
            for (int i = 0; i &lt; stackSize; i++) {<br />
                TreeNode curNode = queue.poll();<br />
                if (curNode.left != null) {<br />
                    queue.offer(curNode.left);<br />
                }<br />
                if (curNode.right != null) {<br />
                    queue.offer(curNode.right);<br />
                }<br />
            }<br />
        }<br />
        return nodeSum;<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdevox9.html">【Android群英传】学习笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqll7o6q.html">解决FragmentTabHost切换标题栏变更问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkrreq.html">Hibernate&lpar;一&rpar;&lowbar;&lowbar;简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2ww1j3q.html">hdu----（1466）计算直线的交点数（dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvvwxzq.html">OC self和super</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okk0w59.html">FG函数模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02lkgq.html">Unity3D研究院之脚本批量打包渠道包研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmggm49.html">我是怎么发现并解决项目页面渲染效率问题的（IE调试工具探查器的使用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdwpzr8.html">Row&lowbar;Number&lpar;&rpar;over&lpar;order by&period;&period;&period;&period;&rpar; as</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmr5k79.html">第二部分 MediaPlayer的接口与架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm66dx9.html">跟我学系列教程&mdash;&mdash;《13天让你学会Redis》火热报名中</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7wnp9.html">PLA能收敛的证明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjd7r9.html">MVC5入门学习系列④</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkenyd8.html">读书笔记 effective c&plus;&plus; Item 16 成对使用new和delete时要用相同的形式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdx1e79.html">Linux学习---vi&sol;vim命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdgkg8.html">js关闭子页面刷新父页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m11zm8.html">iOS设置拍照retake和use按钮为中文简体</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y60gw8.html">如何继承Date对象？由一道题彻底弄懂JS继承。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1r4eq.html">PyCharm 中使用 Pylint 控制代码质量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owrmx8.html">手机端的1px边框如何实现</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qllrl1xq.html">【Ruby】【遇到的问题】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o161wlq.html">理解 Redis&lpar;4&rpar; - 关于 string 的更多命令&lpar;SETEX&comma; SETNX&comma; INCR&comma; DECR&comma; MSET&period;&period;&period;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw4ppk8.html">【五】php 面向对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gepg0q.html">oracle的批量操作sql语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o57je8.html">Oracle（转换函数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyzr619.html">Exception in thread &amp;quot&semi;main&amp;quot&semi; java&period;util&period;regex&period;PatternSyntaxException&colon; Unclosed character class near index 0  解决方法&colon; 要对切割字符进行转义&bsol;&bsol;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwydgx9.html">Spring Bean 定义继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw43nz8.html">Python编码简要说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r521neq.html">Lua面向对象之三：其它一些尝试</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o5gkg8.html">flex属性的学习</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
